#include "PerfectEnvironment_objects.h"
#include "PerfectEnvironment_resources.h"
#include "built_in.h"


// TFT module connections
sbit TFT_BLED at GPIOF_ODR.B10;
sbit TFT_CS at GPIOF_ODR.B12;
sbit TFT_RD at GPIOF_ODR.B14;
sbit TFT_RS at GPIOF_ODR.B13;
sbit TFT_RST at GPIOF_ODR.B11;
sbit TFT_WR at GPIOF_ODR.B15;
unsigned int TFT_DataPort at GPIOG_ODR;
// End TFT module connections


// Global variables
unsigned int Xcoord, Ycoord;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TImage *local_image;
TImage *exec_image;
int image_order;


void Write_to_Data_Lines(  unsigned char _hi, unsigned char _lo ) {
  GPIOG_ODR = ( unsigned int ) ( _lo | ( _hi << 8 ) );
}

void Set_Index( unsigned short index ) {
  TFT_RS = 0;
  Write_to_Data_Lines(  0, index );
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

void Write_Command( unsigned short cmd ) {
  TFT_RS = 1;
  Write_to_Data_Lines( 0, cmd );
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

void Write_Data( unsigned int _data ) {
  TFT_RS = 1;
  Write_to_Data_Lines( Hi( _data ), Lo( _data ) );
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

static void InitializeTouchPanel( ) {
  TFT_Set_Active( Set_Index, Write_Command, Write_Data );
  TFT_Init_SSD1963_Board_43( 480, 272);

  TFT_Set_DBC_SSD1963(255);

  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                Screen1;
  TImage               Image10;
  TImage               Image9;
  TImage               Image11;
  TImage               Image1;
  TImage               Image8;
  TImage               Image7;
  TImage               Image6;
  TImage               Image5;
  TImage               Image3;
  TImage               Image4;
  TImage               Image2;

  TLabel                 Label7;
char Label7_Caption[ 2 ] = "_";

  TLabel                 Label8;
char Label8_Caption[ 2 ] = "_";

  TLabel                 Label9;
char Label9_Caption[ 2 ] = "_";

  TLabel                 Label10;
char Label10_Caption[ 2 ] = "_";

  TLabel                 Label11;
char Label11_Caption[ 2 ] = "_";

  TLabel                 Label12;
char Label12_Caption[ 2 ] = "_";

  TLabel                 Label13;
char Label13_Caption[ 2 ] = "_";

  TButton               Button1;
char Button1_Caption[ 1 ] = "";

  TLabel                 Label14;
char Label14_Caption[ 4 ] = "OFF";

  TButton                * const code Screen1_Buttons[ 1 ]=
         {
         &Button1
         };
  TLabel                 * const code Screen1_Labels[ 8 ]=
         {
         &Label7,
         &Label8,
         &Label9,
         &Label10,
         &Label11,
         &Label12,
         &Label13,
         &Label14
         };
  TImage                 * const code Screen1_Images[ 11 ]=
         {
         &Image10,
         &Image9,
         &Image11,
         &Image1,
         &Image8,
         &Image7,
         &Image6,
         &Image5,
         &Image3,
         &Image4,
         &Image2
         };



static void InitializeObjects( ) {
  Screen1.Color                     = 0x5AEB;
  Screen1.Width                     = 480;
  Screen1.Height                    = 272;
  Screen1.ButtonsCount              = 1;
  Screen1.Buttons                   = Screen1_Buttons;
  Screen1.LabelsCount               = 8;
  Screen1.Labels                    = Screen1_Labels;
  Screen1.ImagesCount               = 11;
  Screen1.Images                    = Screen1_Images;
  Screen1.ObjectsCount              = 20;
  Screen1.OnSwipeUpPtr    = 0;
  Screen1.OnSwipeDownPtr  = 0;
  Screen1.OnSwipeLeftPtr  = 0;
  Screen1.OnSwipeRightPtr = 0;
  Screen1.OnZoomInPtr     = 0;
  Screen1.OnZoomOutPtr    = 0;


  Image10.OwnerScreen     = &Screen1;
  Image10.Order           = 0;
  Image10.Left            = 0;
  Image10.Top             = 203;
  Image10.Width           = 480;
  Image10.Height          = 69;
  Image10.Picture_Type    = 1;
  Image10.Picture_Ratio   = 1;
  Image10.Picture_Name    = water2_jpg;
  Image10.Visible         = 1;
  Image10.Active          = 1;

  Image9.OwnerScreen     = &Screen1;
  Image9.Order           = 1;
  Image9.Left            = 0;
  Image9.Top             = 203;
  Image9.Width           = 480;
  Image9.Height          = 69;
  Image9.Picture_Type    = 1;
  Image9.Picture_Ratio   = 1;
  Image9.Picture_Name    = water1_jpg;
  Image9.Visible         = 1;
  Image9.Active          = 1;

  Image11.OwnerScreen     = &Screen1;
  Image11.Order           = 2;
  Image11.Left            = 0;
  Image11.Top             = 203;
  Image11.Width           = 480;
  Image11.Height          = 69;
  Image11.Picture_Type    = 1;
  Image11.Picture_Ratio   = 1;
  Image11.Picture_Name    = water3_jpg;
  Image11.Visible         = 1;
  Image11.Active          = 1;

  Image1.OwnerScreen     = &Screen1;
  Image1.Order           = 3;
  Image1.Left            = 0;
  Image1.Top             = 0;
  Image1.Width           = 480;
  Image1.Height          = 272;
  Image1.Picture_Type    = 0;
  Image1.Picture_Ratio   = 1;
  Image1.Picture_Name    = screen_bmp;
  Image1.Visible         = 1;
  Image1.Active          = 1;

  Image8.OwnerScreen     = &Screen1;
  Image8.Order           = 4;
  Image8.Left            = 367;
  Image8.Top             = 155;
  Image8.Width           = 79;
  Image8.Height          = 26;
  Image8.Picture_Type    = 1;
  Image8.Picture_Ratio   = 1;
  Image8.Picture_Name    = tv_jpg;
  Image8.Visible         = 1;
  Image8.Active          = 1;

  Image7.OwnerScreen     = &Screen1;
  Image7.Order           = 5;
  Image7.Left            = 255;
  Image7.Top             = 155;
  Image7.Width           = 77;
  Image7.Height          = 27;
  Image7.Picture_Type    = 1;
  Image7.Picture_Ratio   = 1;
  Image7.Picture_Name    = c_jpg;
  Image7.Visible         = 1;
  Image7.Active          = 1;

  Image6.OwnerScreen     = &Screen1;
  Image6.Order           = 6;
  Image6.Left            = 128;
  Image6.Top             = 157;
  Image6.Width           = 110;
  Image6.Height          = 26;
  Image6.Picture_Type    = 0;
  Image6.Picture_Ratio   = 1;
  Image6.Picture_Name    = u_bmp;
  Image6.Visible         = 1;
  Image6.Active          = 1;

  Image5.OwnerScreen     = &Screen1;
  Image5.Order           = 7;
  Image5.Left            = 40;
  Image5.Top             = 154;
  Image5.Width           = 84;
  Image5.Height          = 27;
  Image5.Picture_Type    = 1;
  Image5.Picture_Ratio   = 1;
  Image5.Picture_Name    = p_jpg;
  Image5.Visible         = 1;
  Image5.Active          = 1;

  Image3.OwnerScreen     = &Screen1;
  Image3.Order           = 8;
  Image3.Left            = 234;
  Image3.Top             = 40;
  Image3.Width           = 56;
  Image3.Height          = 45;
  Image3.Picture_Type    = 1;
  Image3.Picture_Ratio   = 1;
  Image3.Picture_Name    = h_jpg;
  Image3.Visible         = 1;
  Image3.Active          = 1;

  Image4.OwnerScreen     = &Screen1;
  Image4.Order           = 9;
  Image4.Left            = 381;
  Image4.Top             = 40;
  Image4.Width           = 71;
  Image4.Height          = 47;
  Image4.Picture_Type    = 1;
  Image4.Picture_Ratio   = 1;
  Image4.Picture_Name    = a_jpg;
  Image4.Visible         = 1;
  Image4.Active          = 1;

  Image2.OwnerScreen     = &Screen1;
  Image2.Order           = 10;
  Image2.Left            = 74;
  Image2.Top             = 40;
  Image2.Width           = 52;
  Image2.Height          = 41;
  Image2.Picture_Type    = 1;
  Image2.Picture_Ratio   = 1;
  Image2.Picture_Name    = t_jpg;
  Image2.Visible         = 1;
  Image2.Active          = 1;

  Label7.OwnerScreen     = &Screen1;
  Label7.Order           = 11;
  Label7.Left            = 74;
  Label7.Top             = 47;
  Label7.Width           = 24;
  Label7.Height          = 32;
  Label7.Visible         = 1;
  Label7.Active          = 1;
  Label7.Caption         = Label7_Caption;
  Label7.FontName        = Tahoma29x29_Bold;
  Label7.Font_Color      = 0xFFFF;
  Label7.VerticalText    = 0;

  Label8.OwnerScreen     = &Screen1;
  Label8.Order           = 12;
  Label8.Left            = 235;
  Label8.Top             = 47;
  Label8.Width           = 24;
  Label8.Height          = 32;
  Label8.Visible         = 1;
  Label8.Active          = 1;
  Label8.Caption         = Label8_Caption;
  Label8.FontName        = Tahoma29x29_Bold;
  Label8.Font_Color      = 0xFFFF;
  Label8.VerticalText    = 0;

  Label9.OwnerScreen     = &Screen1;
  Label9.Order           = 13;
  Label9.Left            = 381;
  Label9.Top             = 47;
  Label9.Width           = 24;
  Label9.Height          = 32;
  Label9.Visible         = 1;
  Label9.Active          = 1;
  Label9.Caption         = Label9_Caption;
  Label9.FontName        = Tahoma29x29_Bold;
  Label9.Font_Color      = 0xFFFF;
  Label9.VerticalText    = 0;

  Label10.OwnerScreen     = &Screen1;
  Label10.Order           = 14;
  Label10.Left            = 40;
  Label10.Top             = 153;
  Label10.Width           = 24;
  Label10.Height          = 32;
  Label10.Visible         = 1;
  Label10.Active          = 1;
  Label10.Caption         = Label10_Caption;
  Label10.FontName        = Tahoma29x29_Bold;
  Label10.Font_Color      = 0xFFFF;
  Label10.VerticalText    = 0;

  Label11.OwnerScreen     = &Screen1;
  Label11.Order           = 15;
  Label11.Left            = 153;
  Label11.Top             = 153;
  Label11.Width           = 24;
  Label11.Height          = 32;
  Label11.Visible         = 1;
  Label11.Active          = 1;
  Label11.Caption         = Label11_Caption;
  Label11.FontName        = Tahoma29x29_Bold;
  Label11.Font_Color      = 0xFFFF;
  Label11.VerticalText    = 0;

  Label12.OwnerScreen     = &Screen1;
  Label12.Order           = 16;
  Label12.Left            = 262;
  Label12.Top             = 153;
  Label12.Width           = 24;
  Label12.Height          = 32;
  Label12.Visible         = 1;
  Label12.Active          = 1;
  Label12.Caption         = Label12_Caption;
  Label12.FontName        = Tahoma29x29_Bold;
  Label12.Font_Color      = 0xFFFF;
  Label12.VerticalText    = 0;

  Label13.OwnerScreen     = &Screen1;
  Label13.Order           = 17;
  Label13.Left            = 373;
  Label13.Top             = 153;
  Label13.Width           = 24;
  Label13.Height          = 32;
  Label13.Visible         = 1;
  Label13.Active          = 1;
  Label13.Caption         = Label13_Caption;
  Label13.FontName        = Tahoma29x29_Bold;
  Label13.Font_Color      = 0xFFFF;
  Label13.VerticalText    = 0;

  Button1.OwnerScreen     = &Screen1;
  Button1.Order           = 18;
  Button1.Left            = 286;
  Button1.Top             = 204;
  Button1.Width           = 71;
  Button1.Height          = 64;
  Button1.Pen_Width       = 0;
  Button1.Pen_Color       = 0xFFFF;
  Button1.Visible         = 1;
  Button1.Active          = 1;
  Button1.Transparent     = 0;
  Button1.Caption         = Button1_Caption;
  Button1.TextAlign       = _taCenter;
  Button1.TextAlignVertical= _tavMiddle;
  Button1.FontName        = Tahoma11x13_Regular;
  Button1.PressColEnabled = 1;
  Button1.Font_Color      = 0x0000;
  Button1.VerticalText    = 0;
  Button1.Gradient        = 1;
  Button1.Gradient_Orientation = 0;
  Button1.Gradient_Start_Color = 0xFFFF;
  Button1.Gradient_End_Color = 0xC618;
  Button1.Color           = 0xC618;
  Button1.Press_Color     = 0xE71C;
  Button1.OnClickPtr      = Button1OnClick;

  Label14.OwnerScreen     = &Screen1;
  Label14.Order           = 19;
  Label14.Left            = 364;
  Label14.Top             = 225;
  Label14.Width           = 44;
  Label14.Height          = 25;
  Label14.Visible         = 1;
  Label14.Active          = 1;
  Label14.Caption         = Label14_Caption;
  Label14.FontName        = Tahoma23x23_Bold;
  Label14.Font_Color      = 0xFFFF;
  Label14.VerticalText    = 0;
}

static char IsInsideObject ( unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height ) { // static
  if ( ( Left<= X ) && ( Left+ Width - 1 >= X ) &&
       ( Top <= Y )  && ( Top + Height - 1 >= Y ) )
    return 1;
  else
    return 0;
}


#define GetButton( index )              CurrentScreen->Buttons[ index ]
#define GetLabel( index )               CurrentScreen->Labels[ index ]
#define GetImage( index )               CurrentScreen->Images[ index ]

void DrawButton( TButton *Abutton ) {
unsigned int ALeft, ATop;
  if ( Abutton->Visible != 0 ) {
    if ( object_pressed == 1 ) {
      object_pressed = 0;
      TFT_Set_Brush( Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color );
    }
    else {
      TFT_Set_Brush( Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color );
    }
    TFT_Set_Pen( Abutton->Pen_Color, Abutton->Pen_Width );
    TFT_Rectangle( Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1 );
    if ( Abutton->VerticalText != 0 )
      TFT_Set_Font( Abutton->FontName, Abutton->Font_Color, FO_VERTICAL_COLUMN );
    else
      TFT_Set_Font( Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL );
    TFT_Write_Text_Return_Pos( Abutton->Caption, Abutton->Left, Abutton->Top);
    if ( Abutton->TextAlign == _taLeft )
      ALeft = Abutton->Left + 4;
    else if ( Abutton->TextAlign == _taCenter )
      ALeft = Abutton->Left + ( Abutton->Width - caption_length ) / 2;
    else if ( Abutton->TextAlign == _taRight )
      ALeft = Abutton->Left + Abutton->Width - caption_length - 4;

    if ( Abutton->TextAlignVertical == _tavTop)
      ATop = Abutton->Top + 4;
    else if ( Abutton->TextAlignVertical == _tavMiddle )
      ATop = Abutton->Top + ( ( Abutton->Height - caption_height ) / 2);
    else if ( Abutton->TextAlignVertical == _tavBottom)
      ATop = Abutton->Top + ( Abutton->Height - caption_height - 4);

    TFT_Write_Text( Abutton->Caption, ALeft, ATop);
  }
}

void DrawLabel( TLabel *ALabel ) {
  if ( ALabel->Visible != 0 ) {
    if ( ALabel->VerticalText != 0 )
      TFT_Set_Font( ALabel->FontName, ALabel->Font_Color, FO_VERTICAL_COLUMN );
    else
      TFT_Set_Font( ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL );
    TFT_Write_Text( ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawImage( TImage *AImage ) {
  if ( AImage->Visible != 0 ) {
    if ( AImage->Picture_Type == 0 )
      TFT_Image( AImage->Left, AImage->Top, AImage->Picture_Name, AImage->Picture_Ratio );
    if ( AImage->Picture_Type == 1 )
      TFT_Image_Jpeg( AImage->Left, AImage->Top, AImage->Picture_Name );
  }
}

void DrawScreen( TScreen *aScreen ) {
 unsigned int order;
  unsigned short button_idx;
  TButton *local_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short image_idx;
  TImage *local_image;
  char save_bled;
  unsigned int i;

  object_pressed = 0;
  order = 0;
  button_idx = 0;
  label_idx = 0;
  image_idx = 0;
  CurrentScreen = aScreen;
  TFT_Set_DBC_SSD1963( 0 );

  if ( ( display_width != CurrentScreen->Width ) || ( display_height != CurrentScreen->Height ) ) {
    save_bled = TFT_BLED;
    TFT_BLED           = 0;
    TFT_Set_Active( Set_Index, Write_Command, Write_Data );
    TFT_Init_SSD1963_Board_43( CurrentScreen->Width, CurrentScreen->Height );
    FT5XX6_SetSize( CurrentScreen->Width, CurrentScreen->Height );
    TFT_Fill_Screen( CurrentScreen->Color );
    //TFT_Set_DBC_SSD1963(255);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_BLED       = save_bled;
  }
  else
    TFT_Fill_Screen( CurrentScreen->Color );


  while ( order < CurrentScreen->ObjectsCount ) {
    if ( button_idx < CurrentScreen->ButtonsCount ) {
      local_button = GetButton( button_idx );
      if ( order == local_button->Order ) {
        button_idx++;
        order++;
        DrawButton( local_button );
      }
    }

    if ( label_idx < CurrentScreen->LabelsCount ) {
      local_label = GetLabel( label_idx );
      if ( order == local_label->Order ) {
        label_idx++;
        order++;
        DrawLabel( local_label );
      }
    }

    if ( image_idx < CurrentScreen->ImagesCount ) {
      local_image = GetImage( image_idx );
      if ( order == local_image->Order ) {
        image_idx++;
        order++;
        DrawImage( local_image );
      }
    }
 }
   for ( i = 0; i < 256; i++ )
   {
      TFT_Set_DBC_SSD1963( i );
      Delay_ms(  15 );
   }
}

void Get_Object( unsigned int X, unsigned int Y) {
  button_order        = -1;
  label_order         = -1;
  image_order         = -1;
  //  Buttons
  for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
    local_button = GetButton( _object_count );
    if ( local_button->Active != 0 ) {
      if ( IsInsideObject( X, Y, local_button->Left, local_button->Top,
                         local_button->Width, local_button->Height ) == 1 ) {
        button_order = local_button->Order;
        exec_button = local_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel( _object_count );
    if ( local_label->Active != 0 ) {
      if ( IsInsideObject( X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height ) == 1 ) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  //  Images
  for ( _object_count = 0 ; _object_count < CurrentScreen->ImagesCount ; _object_count++ ) {
    local_image = GetImage( _object_count );
    if ( local_image->Active != 0 ) {
      if ( IsInsideObject( X, Y, local_image->Left, local_image->Top,
                         local_image->Width, local_image->Height ) == 1 ) {
        image_order = local_image->Order;
        exec_image = local_image;
      }
    }
  }

  _object_count = -1;
  if ( button_order >  _object_count )
    _object_count = button_order;
  if ( label_order >  _object_count )
    _object_count = label_order;
  if ( image_order >  _object_count )
    _object_count = image_order;
}


void Process_TP_Press( unsigned int X, unsigned int Y) {
  exec_button         = 0;
  exec_label          = 0;
  exec_image          = 0;

  Get_Object( X, Y);

  if ( _object_count != -1 ) {
    if ( _object_count == button_order ) {
      if ( exec_button->Active != 0 ) {
        if ( exec_button->OnPressPtr != 0 ) {
          exec_button->OnPressPtr( );
          return;
        }
      }
    }

    if ( _object_count == label_order ) {
      if ( exec_label->Active != 0 ) {
        if ( exec_label->OnPressPtr != 0 ) {
          exec_label->OnPressPtr( );
          return;
        }
      }
    }

    if ( _object_count == image_order ) {
      if ( exec_image->Active != 0 ) {
        if ( exec_image->OnPressPtr != 0 ) {
          exec_image->OnPressPtr( );
          return;
        }
      }
    }

  }
}

void Process_TP_Up( unsigned int X, unsigned int Y) {

  switch ( PressedObjectType ) {
    // Button
    case 0: {
      if ( PressedObject != 0 ) {
        exec_button = ( TButton* )PressedObject;
        if ( ( exec_button->PressColEnabled != 0 ) && ( exec_button->OwnerScreen == CurrentScreen ) ) {
          DrawButton( exec_button );
        }
        break;
      }
      break;
    }
  }

  exec_label          = 0;
  exec_image          = 0;

  Get_Object( X, Y);


  if ( _object_count != -1 ) {
  // Buttons
    if ( _object_count == button_order ) {
      if ( exec_button->Active != 0 ) {
        if ( exec_button->OnUpPtr != 0 )
          exec_button->OnUpPtr( );
        if ( PressedObject == ( void * )exec_button )
          if ( exec_button->OnClickPtr != 0 )
            exec_button->OnClickPtr( );
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if ( _object_count == label_order ) {
      if ( exec_label->Active != 0 ) {
        if ( exec_label->OnUpPtr != 0 )
          exec_label->OnUpPtr( );
        if ( PressedObject == ( void * )exec_label )
          if ( exec_label->OnClickPtr != 0 )
            exec_label->OnClickPtr( );
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Images
    if ( _object_count == image_order ) {
      if ( exec_image->Active != 0 ) {
        if ( exec_image->OnUpPtr != 0 )
          exec_image->OnUpPtr( );
        if ( PressedObject == ( void * )exec_image )
          if ( exec_image->OnClickPtr != 0 )
            exec_image->OnClickPtr( );
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

void Process_TP_Down( unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_button         = 0;
  exec_label          = 0;
  exec_image          = 0;

  Get_Object( X, Y);

  if ( _object_count != -1 ) {
    if ( _object_count == button_order ) {
      if ( exec_button->Active != 0 ) {
        if ( exec_button->PressColEnabled != 0 ) {
          object_pressed = 1;
          DrawButton( exec_button );
        }
        PressedObject = ( void * )exec_button;
        PressedObjectType = 0;
        if ( exec_button->OnDownPtr != 0 ) {
          exec_button->OnDownPtr( );
          return;
        }
      }
    }

    if ( _object_count == label_order ) {
      if ( exec_label->Active != 0 ) {
        PressedObject = ( void * )exec_label;
        PressedObjectType = 2;
        if ( exec_label->OnDownPtr != 0 ) {
          exec_label->OnDownPtr( );
          return;
        }
      }
    }

    if ( _object_count == image_order ) {
      if ( exec_image->Active != 0 ) {
        PressedObject = ( void * )exec_image;
        PressedObjectType = 3;
        if ( exec_image->OnDownPtr != 0 ) {
          exec_image->OnDownPtr( );
          return;
        }
      }
    }

  }
}

void Check_TP( ) {
  if ( FT5XX6_PressDetect( ) ) {
    if ( FT5XX6_GetCoordinates( &Xcoord, &Ycoord ) == 0 ) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
      Process_TP_Press( Xcoord, Ycoord );
      if ( PenDown == 0 ) {
        PenDown = 1;
        Process_TP_Down( Xcoord, Ycoord );
      }
    }
  }
  else if ( PenDown == 1 ) {
    PenDown = 0;
    Process_TP_Up( Xcoord, Ycoord );
  }
}

void Init_MCU( )
{  // If bus is busy wait SDA high before initializing I2C module
  GPIO_Digital_Output( &GPIOF_BASE, _GPIO_PINMASK_1 );
  GPIO_Digital_Input( &GPIOF_BASE, _GPIO_PINMASK_0 );
  GPIOF_ODR.B1 = 1;
  while ( GPIOF_IDR.B0 == 0 ) {
    GPIOF_ODR.B1 = 0;
    Delay_us( 10 );
    GPIOF_ODR.B1 = 1;
    Delay_us( 10 );
  }
  I2C2_Init_Advanced( 400000, &_GPIO_MODULE_I2C2_PF01 );

  TFT_Set_Default_Mode( );
}

char FT5XX6_Config( )  {
  FT5XX6_SetI2CAddress( 0x38 );
  if ( FT5XX6_IsOperational( ) != FT5XX6_OK )
    return  FT5XX6_FAILURE;
  FT5XX6_SetDefaultMode( );
  FT5XX6_SetController( _TC_FT5X16);
  FT5XX6_SetSizeAndRotation( 480,272,0 );
return FT5XX6_OK;
}

void Start_TP( ) {
  Init_MCU( );

  InitializeTouchPanel( );
  if ( FT5XX6_Config( ) == FT5XX6_OK ) {
  } else {
    while(1 );
  }

  InitializeObjects( );
  display_width = Screen1.Width;
  display_height = Screen1.Height;
  DrawScreen( &Screen1 );
}